from typing import Generic, TypeVar

from rainbowadn.data.collection.collection_interface.collectioninterface import CollectionInterface
from rainbowadn.hashing.hashpoint import HashPoint

__all__ = ('ActiveCollectionInterface',)

CollectionType = TypeVar('CollectionType')
KeyType = TypeVar('KeyType')


class ActiveCollectionInterface(CollectionInterface[CollectionType], Generic[CollectionType, KeyType]):
    def add(self, key: HashPoint[KeyType]) -> 'ActiveCollectionInterface[KeyType]':
        raise NotImplementedError
