from typing import Generic, TypeVar

from rainbowadn.hashing.nullability.nullablereference import NullableReference

__all__ = ('CollectionFactory',)

CollectionType = TypeVar('CollectionType')
InterfaceType = TypeVar('InterfaceType')


class CollectionFactory(
    Generic[CollectionType, InterfaceType],
):
    """вперёд, уроды, вас ждут заводы"""

    def from_reference(self, source: NullableReference[CollectionType]) -> InterfaceType:
        raise NotImplementedError
