from typing import Generic, TypeVar

from rainbowadn.hashing.nullability.nullable import Nullable

__all__ = ('Null',)

NullableType = TypeVar('NullableType')


class Null(Nullable[NullableType], Generic[NullableType]):
    def __eq__(self, other):
        if isinstance(other, Null):
            return True
        else:
            return NotImplemented
