from typing import Generic, TypeVar

from rainbowadn.hashing.hashresolver import HashResolver

__all__ = ('RainbowFactory',)

FHashMentioned = TypeVar('FHashMentioned')


class RainbowFactory(Generic[FHashMentioned]):
    """вперёд, уроды, вас ждут заводы"""

    def from_bytes(self, source: bytes, resolver: HashResolver) -> FHashMentioned:
        raise NotImplementedError
